/*
	UnWindows 1.0
	Eyes.h

	Gary Ormsby
	Rensselaer Polytechnic Institute
	Fall 1991

	This file contains structures used in the Eyes.c file.
*/

/*
* $XConsortium: Eyes.h,v 1.6 89/07/21 13:48:59 jim Exp $
*/

#ifndef _XtEyes_h
#define _XtEyes_h

/***********************************************************************
 *
 * Eyes Widget
 *
 ***********************************************************************/

/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		pixel		White
 border		     BorderColor	pixel		Black
 borderWidth	     BorderWidth	int		1
 foreground	     Foreground		Pixel		Black
 outline	     Outline		Pixel		Black
 height		     Height		int		120
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 reverseVideo	     ReverseVideo	Boolean		False
 width		     Width		int		120
 x		     Position		int		0
 y		     Position		int		0

*/

#define XtNoutline	"outline"
#define XtNcenterColor	"center"

#ifdef SHAPE
#define XtNshapeWindow	"shapeWindow"
#define XtCShapeWindow	"ShapeWindow"
#endif

typedef struct _EyesRec *EyesWidget; 		/* completely defined in EyesPrivate.h */
typedef struct _EyesClassRec *EyesWidgetClass;    /* completely defined in EyesPrivate.h */

typedef struct _EyesColorRec {                  /* new */
        char	eyes_color[120];                /* new */
        float   eyes_loffset;                   /* new */
        float   eyes_uoffset;                   /* new */
	int	number;				/* new */
        XColor  xcolor;                         /* new */
        GC      colorGC;                        /* new */
        }	EyesColorRec;                   /* new */

typedef struct _EyesColorDefRec {		/* new */
	XColor	xcolor;				/* new */
	GC	colorGC;			/* new */
	}	EyesColorDefRec;		/* new */

extern WidgetClass eyesWidgetClass;

#endif /* _XtEyes_h */
/* DON'T ADD STUFF AFTER THIS #endif */
